<template>
	<div class="general-menu">
		<div class="submenu-title">OPTIONS</div>
		<component
			v-for="item in items"
			v-on:click="onClick"
			v-on:hover="setSelected"
			:id="item.id"
			:is="item.type"
			:key="item.id"
			:selected="item.id === selected"
		>{{ item.text }}</component>
	</div>
</template>

<script>
import StandardItem from "../components/StandardItem.vue"

export default {
	components: { StandardItem },
	created () {
		UI.on("PRESS_UP", () => {
			if (this.mounted) this.setSelected(Math.max(0, this.selected - 1))
		})
		UI.on("PRESS_DOWN", () => {
			if (this.mounted) this.setSelected(Math.min(this.items.length - 1, this.selected + 1))
		})
		UI.on("PRESS_ACCEPT", () => {
			if (this.mounted) this.onClick(this.selected)
		})
		UI.on("CHANGE_LANGUAGE", () => {
			this.onLanguageChange()
		})
	},
	data () {
		return {
			items: [{
				id: 0,
				text: "Language",
				type: "standard-item"
			}],
			mounted: false,
			selected: 0
		}
	},
	destroyed () {
		this.mounted = false
	},
	methods: {
		onClick: function (id) {
			UI.emit("SELECT_GENERAL", id)
		},
		onLanguageChange: function () {
			this.items[0].text = Language.get("LANGUAGE")
			// this.items[1].text = Language.get("LOCAL")
			// this.items[2].text = Language.get("OPTIONS")
			// this.items[3].text = Language.get("QUIT")
		},
		setSelected: function (id) {
			this.selected = id
		}
	},
	mounted () {
		this.mounted = true
	},
	name: "options-menu"
}
</script>

<style lang="less" scoped>
.logo {
	height: 16em;
	left: 0;
	position: absolute;
	top: 0;
}

.general-menu {
	bottom: 12em;
	display: flex;
	flex-direction: column;
	height: 56em;
	justify-content: flex-end;
	position: absolute;
	left: 16em;
	transition: background-color .5s ease;
	width: 40em;
}

.submenu-title {
	color: #fff;
	font-size: 6em;
	font-weight: bold;
	left: 0;
	position: absolute;
	top: 0;
}
</style>